Code

1499a67bba6bf9372d38acf890151bd802773953
[git.git] / git-rebase--interactive.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2006 Johannes E. Schindelin
5 # SHORT DESCRIPTION
6 #
7 # This script makes it easy to fix up commits in the middle of a series,
8 # and rearrange commits.
9 #
10 # The original idea comes from Eric W. Biederman, in
11 # http://article.gmane.org/gmane.comp.version-control.git/22407
13 OPTIONS_KEEPDASHDASH=
14 OPTIONS_SPEC="\
15 git-rebase [-i] [options] [--] <upstream> [<branch>]
16 git-rebase [-i] (--continue | --abort | --skip)
17 --
18  Available options are
19 v,verbose          display a diffstat of what changed upstream
20 onto=              rebase onto given branch instead of upstream
21 p,preserve-merges  try to recreate merges instead of ignoring them
22 s,strategy=        use the given merge strategy
23 m,merge            always used (no-op)
24 i,interactive      always used (no-op)
25  Actions:
26 continue           continue rebasing process
27 abort              abort rebasing process and restore original branch
28 skip               skip current patch and continue rebasing process
29 no-verify          override pre-rebase hook from stopping the operation
30 root               rebase all reachable commmits up to the root(s)
31 "
33 . git-sh-setup
34 require_work_tree
36 DOTEST="$GIT_DIR/rebase-merge"
38 # The file containing rebase commands, comments, and empty lines.
39 # This file is created by "git rebase -i" then edited by the user.  As
40 # the lines are processed, they are removed from the front of this
41 # file and written to the tail of $DONE.
42 TODO="$DOTEST"/git-rebase-todo
44 # The rebase command lines that have already been processed.  A line
45 # is moved here when it is first handled, before any associated user
46 # actions.
47 DONE="$DOTEST"/done
49 # The commit message that is planned to be used for any changes that
50 # need to be committed following a user interaction.
51 MSG="$DOTEST"/message
53 # The file into which is accumulated the suggested commit message for
54 # squash/fixup commands.  When the first of a series of squash/fixups
55 # is seen, the file is created and the commit message from the
56 # previous commit and from the first squash/fixup commit are written
57 # to it.  The commit message for each subsequent squash/fixup commit
58 # is appended to the file as it is processed.
59 #
60 # The first line of the file is of the form
61 #     # This is a combination of $COUNT commits.
62 # where $COUNT is the number of commits whose messages have been
63 # written to the file so far (including the initial "pick" commit).
64 # Each time that a commit message is processed, this line is read and
65 # updated.  It is deleted just before the combined commit is made.
66 SQUASH_MSG="$DOTEST"/message-squash
68 # $REWRITTEN is the name of a directory containing files for each
69 # commit that is reachable by at least one merge base of $HEAD and
70 # $UPSTREAM. They are not necessarily rewritten, but their children
71 # might be.  This ensures that commits on merged, but otherwise
72 # unrelated side branches are left alone. (Think "X" in the man page's
73 # example.)
74 REWRITTEN="$DOTEST"/rewritten
76 DROPPED="$DOTEST"/dropped
78 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
79 # GIT_AUTHOR_DATE that will be used for the commit that is currently
80 # being rebased.
81 AUTHOR_SCRIPT="$DOTEST"/author-script
83 # When an "edit" rebase command is being processed, the SHA1 of the
84 # commit to be edited is recorded in this file.  When "git rebase
85 # --continue" is executed, if there are any staged changes then they
86 # will be amended to the HEAD commit, but only provided the HEAD
87 # commit is still the commit to be edited.  When any other rebase
88 # command is processed, this file is deleted.
89 AMEND="$DOTEST"/amend
91 PRESERVE_MERGES=
92 STRATEGY=
93 ONTO=
94 VERBOSE=
95 OK_TO_SKIP_PRE_REBASE=
96 REBASE_ROOT=
98 GIT_CHERRY_PICK_HELP="  After resolving the conflicts,
99 mark the corrected paths with 'git add <paths>', and
100 run 'git rebase --continue'"
101 export GIT_CHERRY_PICK_HELP
103 warn () {
104         echo "$*" >&2
107 output () {
108         case "$VERBOSE" in
109         '')
110                 output=$("$@" 2>&1 )
111                 status=$?
112                 test $status != 0 && printf "%s\n" "$output"
113                 return $status
114                 ;;
115         *)
116                 "$@"
117                 ;;
118         esac
121 # Output the commit message for the specified commit.
122 commit_message () {
123         git cat-file commit "$1" | sed "1,/^$/d"
126 run_pre_rebase_hook () {
127         if test -z "$OK_TO_SKIP_PRE_REBASE" &&
128            test -x "$GIT_DIR/hooks/pre-rebase"
129         then
130                 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
131                         echo >&2 "The pre-rebase hook refused to rebase."
132                         exit 1
133                 }
134         fi
137 require_clean_work_tree () {
138         # test if working tree is dirty
139         git rev-parse --verify HEAD > /dev/null &&
140         git update-index --ignore-submodules --refresh &&
141         git diff-files --quiet --ignore-submodules &&
142         git diff-index --cached --quiet HEAD --ignore-submodules -- ||
143         die "Working tree is dirty"
146 ORIG_REFLOG_ACTION="$GIT_REFLOG_ACTION"
148 comment_for_reflog () {
149         case "$ORIG_REFLOG_ACTION" in
150         ''|rebase*)
151                 GIT_REFLOG_ACTION="rebase -i ($1)"
152                 export GIT_REFLOG_ACTION
153                 ;;
154         esac
157 last_count=
158 mark_action_done () {
159         sed -e 1q < "$TODO" >> "$DONE"
160         sed -e 1d < "$TODO" >> "$TODO".new
161         mv -f "$TODO".new "$TODO"
162         count=$(sane_grep -c '^[^#]' < "$DONE")
163         total=$(($count+$(sane_grep -c '^[^#]' < "$TODO")))
164         if test "$last_count" != "$count"
165         then
166                 last_count=$count
167                 printf "Rebasing (%d/%d)\r" $count $total
168                 test -z "$VERBOSE" || echo
169         fi
172 make_patch () {
173         sha1_and_parents="$(git rev-list --parents -1 "$1")"
174         case "$sha1_and_parents" in
175         ?*' '?*' '?*)
176                 git diff --cc $sha1_and_parents
177                 ;;
178         ?*' '?*)
179                 git diff-tree -p "$1^!"
180                 ;;
181         *)
182                 echo "Root commit"
183                 ;;
184         esac > "$DOTEST"/patch
185         test -f "$MSG" ||
186                 commit_message "$1" > "$MSG"
187         test -f "$AUTHOR_SCRIPT" ||
188                 get_author_ident_from_commit "$1" > "$AUTHOR_SCRIPT"
191 die_with_patch () {
192         make_patch "$1"
193         git rerere
194         die "$2"
197 die_abort () {
198         rm -rf "$DOTEST"
199         die "$1"
202 has_action () {
203         sane_grep '^[^#]' "$1" >/dev/null
206 pick_one () {
207         no_ff=
208         case "$1" in -n) sha1=$2; no_ff=t ;; *) sha1=$1 ;; esac
209         output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
210         test -d "$REWRITTEN" &&
211                 pick_one_preserving_merges "$@" && return
212         if test -n "$REBASE_ROOT"
213         then
214                 output git cherry-pick "$@"
215                 return
216         fi
217         parent_sha1=$(git rev-parse --verify $sha1^) ||
218                 die "Could not get the parent of $sha1"
219         current_sha1=$(git rev-parse --verify HEAD)
220         if test -z "$no_ff" -a "$current_sha1" = "$parent_sha1"
221         then
222                 output git reset --hard $sha1
223                 output warn Fast-forward to $(git rev-parse --short $sha1)
224         else
225                 output git cherry-pick "$@"
226         fi
229 pick_one_preserving_merges () {
230         fast_forward=t
231         case "$1" in
232         -n)
233                 fast_forward=f
234                 sha1=$2
235                 ;;
236         *)
237                 sha1=$1
238                 ;;
239         esac
240         sha1=$(git rev-parse $sha1)
242         if test -f "$DOTEST"/current-commit
243         then
244                 if test "$fast_forward" = t
245                 then
246                         cat "$DOTEST"/current-commit | while read current_commit
247                         do
248                                 git rev-parse HEAD > "$REWRITTEN"/$current_commit
249                         done
250                         rm "$DOTEST"/current-commit ||
251                         die "Cannot write current commit's replacement sha1"
252                 fi
253         fi
255         echo $sha1 >> "$DOTEST"/current-commit
257         # rewrite parents; if none were rewritten, we can fast-forward.
258         new_parents=
259         pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
260         if test "$pend" = " "
261         then
262                 pend=" root"
263         fi
264         while [ "$pend" != "" ]
265         do
266                 p=$(expr "$pend" : ' \([^ ]*\)')
267                 pend="${pend# $p}"
269                 if test -f "$REWRITTEN"/$p
270                 then
271                         new_p=$(cat "$REWRITTEN"/$p)
273                         # If the todo reordered commits, and our parent is marked for
274                         # rewriting, but hasn't been gotten to yet, assume the user meant to
275                         # drop it on top of the current HEAD
276                         if test -z "$new_p"
277                         then
278                                 new_p=$(git rev-parse HEAD)
279                         fi
281                         test $p != $new_p && fast_forward=f
282                         case "$new_parents" in
283                         *$new_p*)
284                                 ;; # do nothing; that parent is already there
285                         *)
286                                 new_parents="$new_parents $new_p"
287                                 ;;
288                         esac
289                 else
290                         if test -f "$DROPPED"/$p
291                         then
292                                 fast_forward=f
293                                 replacement="$(cat "$DROPPED"/$p)"
294                                 test -z "$replacement" && replacement=root
295                                 pend=" $replacement$pend"
296                         else
297                                 new_parents="$new_parents $p"
298                         fi
299                 fi
300         done
301         case $fast_forward in
302         t)
303                 output warn "Fast-forward to $sha1"
304                 output git reset --hard $sha1 ||
305                         die "Cannot fast-forward to $sha1"
306                 ;;
307         f)
308                 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
310                 if [ "$1" != "-n" ]
311                 then
312                         # detach HEAD to current parent
313                         output git checkout $first_parent 2> /dev/null ||
314                                 die "Cannot move HEAD to $first_parent"
315                 fi
317                 case "$new_parents" in
318                 ' '*' '*)
319                         test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
321                         # redo merge
322                         author_script=$(get_author_ident_from_commit $sha1)
323                         eval "$author_script"
324                         msg="$(commit_message $sha1)"
325                         # No point in merging the first parent, that's HEAD
326                         new_parents=${new_parents# $first_parent}
327                         if ! GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
328                                 GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
329                                 GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
330                                 output git merge $STRATEGY -m "$msg" \
331                                         $new_parents
332                         then
333                                 printf "%s\n" "$msg" > "$GIT_DIR"/MERGE_MSG
334                                 die_with_patch $sha1 "Error redoing merge $sha1"
335                         fi
336                         ;;
337                 *)
338                         output git cherry-pick "$@" ||
339                                 die_with_patch $sha1 "Could not pick $sha1"
340                         ;;
341                 esac
342                 ;;
343         esac
346 nth_string () {
347         case "$1" in
348         *1[0-9]|*[04-9]) echo "$1"th;;
349         *1) echo "$1"st;;
350         *2) echo "$1"nd;;
351         *3) echo "$1"rd;;
352         esac
355 make_squash_message () {
356         if test -f "$SQUASH_MSG"; then
357                 COUNT=$(($(sed -n \
358                         -e "1s/^# This is a combination of \(.*\) commits\./\1/p" \
359                         -e "q" < "$SQUASH_MSG")+1))
360                 echo "# This is a combination of $COUNT commits."
361                 sed -e 1d -e '2,/^./{
362                         /^$/d
363                 }' <"$SQUASH_MSG"
364         else
365                 COUNT=2
366                 echo "# This is a combination of 2 commits."
367                 echo "# The first commit's message is:"
368                 echo
369                 commit_message HEAD
370         fi
371         case $1 in
372         squash)
373                 echo
374                 echo "# This is the $(nth_string $COUNT) commit message:"
375                 echo
376                 commit_message $2
377                 ;;
378         fixup)
379                 echo
380                 echo "# The $(nth_string $COUNT) commit message will be skipped:"
381                 echo
382                 commit_message $2 | sed -e 's/^/#       /'
383                 ;;
384         esac
387 peek_next_command () {
388         sed -n -e "/^#/d" -e "/^$/d" -e "s/ .*//p" -e "q" < "$TODO"
391 do_next () {
392         rm -f "$MSG" "$AUTHOR_SCRIPT" "$AMEND" || exit
393         read command sha1 rest < "$TODO"
394         case "$command" in
395         '#'*|''|noop)
396                 mark_action_done
397                 ;;
398         pick|p)
399                 comment_for_reflog pick
401                 mark_action_done
402                 pick_one $sha1 ||
403                         die_with_patch $sha1 "Could not apply $sha1... $rest"
404                 ;;
405         reword|r)
406                 comment_for_reflog reword
408                 mark_action_done
409                 pick_one $sha1 ||
410                         die_with_patch $sha1 "Could not apply $sha1... $rest"
411                 git commit --amend
412                 ;;
413         edit|e)
414                 comment_for_reflog edit
416                 mark_action_done
417                 pick_one $sha1 ||
418                         die_with_patch $sha1 "Could not apply $sha1... $rest"
419                 make_patch $sha1
420                 git rev-parse --verify HEAD > "$AMEND"
421                 warn "Stopped at $sha1... $rest"
422                 warn "You can amend the commit now, with"
423                 warn
424                 warn "  git commit --amend"
425                 warn
426                 warn "Once you are satisfied with your changes, run"
427                 warn
428                 warn "  git rebase --continue"
429                 warn
430                 exit 0
431                 ;;
432         squash|s|fixup|f)
433                 case "$command" in
434                 squash|s)
435                         squash_style=squash
436                         ;;
437                 fixup|f)
438                         squash_style=fixup
439                         ;;
440                 esac
441                 comment_for_reflog $squash_style
443                 test -f "$DONE" && has_action "$DONE" ||
444                         die "Cannot '$squash_style' without a previous commit"
446                 mark_action_done
447                 make_squash_message $squash_style $sha1 > "$MSG"
448                 failed=f
449                 author_script=$(get_author_ident_from_commit HEAD)
450                 output git reset --soft HEAD^
451                 pick_one -n $sha1 || failed=t
452                 case "$(peek_next_command)" in
453                 squash|s|fixup|f)
454                         USE_OUTPUT=output
455                         MSG_OPT=-F
456                         EDIT_OR_FILE="$MSG"
457                         cp "$MSG" "$SQUASH_MSG"
458                         ;;
459                 *)
460                         USE_OUTPUT=
461                         MSG_OPT=
462                         EDIT_OR_FILE=-e
463                         rm -f "$SQUASH_MSG" || exit
464                         cp "$MSG" "$GIT_DIR"/SQUASH_MSG
465                         rm -f "$GIT_DIR"/MERGE_MSG || exit
466                         ;;
467                 esac
468                 echo "$author_script" > "$AUTHOR_SCRIPT"
469                 if test $failed = f
470                 then
471                         # This is like --amend, but with a different message
472                         eval "$author_script"
473                         GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
474                         GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
475                         GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
476                         $USE_OUTPUT git commit --no-verify \
477                                 $MSG_OPT "$EDIT_OR_FILE" || failed=t
478                 fi
479                 if test $failed = t
480                 then
481                         cp "$MSG" "$GIT_DIR"/MERGE_MSG
482                         warn
483                         warn "Could not apply $sha1... $rest"
484                         die_with_patch $sha1 ""
485                 fi
486                 ;;
487         *)
488                 warn "Unknown command: $command $sha1 $rest"
489                 if git rev-parse --verify -q "$sha1" >/dev/null
490                 then
491                         die_with_patch $sha1 "Please fix this in the file $TODO."
492                 else
493                         die "Please fix this in the file $TODO."
494                 fi
495                 ;;
496         esac
497         test -s "$TODO" && return
499         comment_for_reflog finish &&
500         HEADNAME=$(cat "$DOTEST"/head-name) &&
501         OLDHEAD=$(cat "$DOTEST"/head) &&
502         SHORTONTO=$(git rev-parse --short $(cat "$DOTEST"/onto)) &&
503         NEWHEAD=$(git rev-parse HEAD) &&
504         case $HEADNAME in
505         refs/*)
506                 message="$GIT_REFLOG_ACTION: $HEADNAME onto $SHORTONTO" &&
507                 git update-ref -m "$message" $HEADNAME $NEWHEAD $OLDHEAD &&
508                 git symbolic-ref HEAD $HEADNAME
509                 ;;
510         esac && {
511                 test ! -f "$DOTEST"/verbose ||
512                         git diff-tree --stat $(cat "$DOTEST"/head)..HEAD
513         } &&
514         rm -rf "$DOTEST" &&
515         git gc --auto &&
516         warn "Successfully rebased and updated $HEADNAME."
518         exit
521 do_rest () {
522         while :
523         do
524                 do_next
525         done
528 # skip picking commits whose parents are unchanged
529 skip_unnecessary_picks () {
530         fd=3
531         while read command sha1 rest
532         do
533                 # fd=3 means we skip the command
534                 case "$fd,$command,$(git rev-parse --verify --quiet $sha1^)" in
535                 3,pick,"$ONTO"*|3,p,"$ONTO"*)
536                         # pick a commit whose parent is current $ONTO -> skip
537                         ONTO=$sha1
538                         ;;
539                 3,#*|3,,*)
540                         # copy comments
541                         ;;
542                 *)
543                         fd=1
544                         ;;
545                 esac
546                 echo "$command${sha1:+ }$sha1${rest:+ }$rest" >&$fd
547         done <"$TODO" >"$TODO.new" 3>>"$DONE" &&
548         mv -f "$TODO".new "$TODO" ||
549         die "Could not skip unnecessary pick commands"
552 # check if no other options are set
553 is_standalone () {
554         test $# -eq 2 -a "$2" = '--' &&
555         test -z "$ONTO" &&
556         test -z "$PRESERVE_MERGES" &&
557         test -z "$STRATEGY" &&
558         test -z "$VERBOSE"
561 get_saved_options () {
562         test -d "$REWRITTEN" && PRESERVE_MERGES=t
563         test -f "$DOTEST"/strategy && STRATEGY="$(cat "$DOTEST"/strategy)"
564         test -f "$DOTEST"/verbose && VERBOSE=t
565         test -f "$DOTEST"/rebase-root && REBASE_ROOT=t
568 while test $# != 0
569 do
570         case "$1" in
571         --no-verify)
572                 OK_TO_SKIP_PRE_REBASE=yes
573                 ;;
574         --verify)
575                 ;;
576         --continue)
577                 is_standalone "$@" || usage
578                 get_saved_options
579                 comment_for_reflog continue
581                 test -d "$DOTEST" || die "No interactive rebase running"
583                 # Sanity check
584                 git rev-parse --verify HEAD >/dev/null ||
585                         die "Cannot read HEAD"
586                 git update-index --ignore-submodules --refresh &&
587                         git diff-files --quiet --ignore-submodules ||
588                         die "Working tree is dirty"
590                 # do we have anything to commit?
591                 if git diff-index --cached --quiet --ignore-submodules HEAD --
592                 then
593                         : Nothing to commit -- skip this
594                 else
595                         . "$AUTHOR_SCRIPT" ||
596                                 die "Cannot find the author identity"
597                         amend=
598                         if test -f "$AMEND"
599                         then
600                                 amend=$(git rev-parse --verify HEAD)
601                                 test "$amend" = $(cat "$AMEND") ||
602                                 die "\
603 You have uncommitted changes in your working tree. Please, commit them
604 first and then run 'git rebase --continue' again."
605                                 git reset --soft HEAD^ ||
606                                 die "Cannot rewind the HEAD"
607                         fi
608                         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE &&
609                         git commit --no-verify -F "$MSG" -e || {
610                                 test -n "$amend" && git reset --soft $amend
611                                 die "Could not commit staged changes."
612                         }
613                 fi
615                 require_clean_work_tree
616                 do_rest
617                 ;;
618         --abort)
619                 is_standalone "$@" || usage
620                 get_saved_options
621                 comment_for_reflog abort
623                 git rerere clear
624                 test -d "$DOTEST" || die "No interactive rebase running"
626                 HEADNAME=$(cat "$DOTEST"/head-name)
627                 HEAD=$(cat "$DOTEST"/head)
628                 case $HEADNAME in
629                 refs/*)
630                         git symbolic-ref HEAD $HEADNAME
631                         ;;
632                 esac &&
633                 output git reset --hard $HEAD &&
634                 rm -rf "$DOTEST"
635                 exit
636                 ;;
637         --skip)
638                 is_standalone "$@" || usage
639                 get_saved_options
640                 comment_for_reflog skip
642                 git rerere clear
643                 test -d "$DOTEST" || die "No interactive rebase running"
645                 output git reset --hard && do_rest
646                 ;;
647         -s)
648                 case "$#,$1" in
649                 *,*=*)
650                         STRATEGY="-s "$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
651                 1,*)
652                         usage ;;
653                 *)
654                         STRATEGY="-s $2"
655                         shift ;;
656                 esac
657                 ;;
658         -m)
659                 # we use merge anyway
660                 ;;
661         -v)
662                 VERBOSE=t
663                 ;;
664         -p)
665                 PRESERVE_MERGES=t
666                 ;;
667         -i)
668                 # yeah, we know
669                 ;;
670         --root)
671                 REBASE_ROOT=t
672                 ;;
673         --onto)
674                 shift
675                 ONTO=$(git rev-parse --verify "$1") ||
676                         die "Does not point to a valid commit: $1"
677                 ;;
678         --)
679                 shift
680                 test -z "$REBASE_ROOT" -a $# -ge 1 -a $# -le 2 ||
681                 test ! -z "$REBASE_ROOT" -a $# -le 1 || usage
682                 test -d "$DOTEST" &&
683                         die "Interactive rebase already started"
685                 git var GIT_COMMITTER_IDENT >/dev/null ||
686                         die "You need to set your committer info first"
688                 if test -z "$REBASE_ROOT"
689                 then
690                         UPSTREAM_ARG="$1"
691                         UPSTREAM=$(git rev-parse --verify "$1") || die "Invalid base"
692                         test -z "$ONTO" && ONTO=$UPSTREAM
693                         shift
694                 else
695                         UPSTREAM=
696                         UPSTREAM_ARG=--root
697                         test -z "$ONTO" &&
698                                 die "You must specify --onto when using --root"
699                 fi
700                 run_pre_rebase_hook "$UPSTREAM_ARG" "$@"
702                 comment_for_reflog start
704                 require_clean_work_tree
706                 if test ! -z "$1"
707                 then
708                         output git show-ref --verify --quiet "refs/heads/$1" ||
709                                 die "Invalid branchname: $1"
710                         output git checkout "$1" ||
711                                 die "Could not checkout $1"
712                 fi
714                 HEAD=$(git rev-parse --verify HEAD) || die "No HEAD?"
715                 mkdir "$DOTEST" || die "Could not create temporary $DOTEST"
717                 : > "$DOTEST"/interactive || die "Could not mark as interactive"
718                 git symbolic-ref HEAD > "$DOTEST"/head-name 2> /dev/null ||
719                         echo "detached HEAD" > "$DOTEST"/head-name
721                 echo $HEAD > "$DOTEST"/head
722                 case "$REBASE_ROOT" in
723                 '')
724                         rm -f "$DOTEST"/rebase-root ;;
725                 *)
726                         : >"$DOTEST"/rebase-root ;;
727                 esac
728                 echo $ONTO > "$DOTEST"/onto
729                 test -z "$STRATEGY" || echo "$STRATEGY" > "$DOTEST"/strategy
730                 test t = "$VERBOSE" && : > "$DOTEST"/verbose
731                 if test t = "$PRESERVE_MERGES"
732                 then
733                         if test -z "$REBASE_ROOT"
734                         then
735                                 mkdir "$REWRITTEN" &&
736                                 for c in $(git merge-base --all $HEAD $UPSTREAM)
737                                 do
738                                         echo $ONTO > "$REWRITTEN"/$c ||
739                                                 die "Could not init rewritten commits"
740                                 done
741                         else
742                                 mkdir "$REWRITTEN" &&
743                                 echo $ONTO > "$REWRITTEN"/root ||
744                                         die "Could not init rewritten commits"
745                         fi
746                         # No cherry-pick because our first pass is to determine
747                         # parents to rewrite and skipping dropped commits would
748                         # prematurely end our probe
749                         MERGES_OPTION=
750                         first_after_upstream="$(git rev-list --reverse --first-parent $UPSTREAM..$HEAD | head -n 1)"
751                 else
752                         MERGES_OPTION="--no-merges --cherry-pick"
753                 fi
755                 SHORTHEAD=$(git rev-parse --short $HEAD)
756                 SHORTONTO=$(git rev-parse --short $ONTO)
757                 if test -z "$REBASE_ROOT"
758                         # this is now equivalent to ! -z "$UPSTREAM"
759                 then
760                         SHORTUPSTREAM=$(git rev-parse --short $UPSTREAM)
761                         REVISIONS=$UPSTREAM...$HEAD
762                         SHORTREVISIONS=$SHORTUPSTREAM..$SHORTHEAD
763                 else
764                         REVISIONS=$ONTO...$HEAD
765                         SHORTREVISIONS=$SHORTHEAD
766                 fi
767                 git rev-list $MERGES_OPTION --pretty=oneline --abbrev-commit \
768                         --abbrev=7 --reverse --left-right --topo-order \
769                         $REVISIONS | \
770                         sed -n "s/^>//p" | while read shortsha1 rest
771                 do
772                         if test t != "$PRESERVE_MERGES"
773                         then
774                                 echo "pick $shortsha1 $rest" >> "$TODO"
775                         else
776                                 sha1=$(git rev-parse $shortsha1)
777                                 if test -z "$REBASE_ROOT"
778                                 then
779                                         preserve=t
780                                         for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
781                                         do
782                                                 if test -f "$REWRITTEN"/$p -a \( $p != $ONTO -o $sha1 = $first_after_upstream \)
783                                                 then
784                                                         preserve=f
785                                                 fi
786                                         done
787                                 else
788                                         preserve=f
789                                 fi
790                                 if test f = "$preserve"
791                                 then
792                                         touch "$REWRITTEN"/$sha1
793                                         echo "pick $shortsha1 $rest" >> "$TODO"
794                                 fi
795                         fi
796                 done
798                 # Watch for commits that been dropped by --cherry-pick
799                 if test t = "$PRESERVE_MERGES"
800                 then
801                         mkdir "$DROPPED"
802                         # Save all non-cherry-picked changes
803                         git rev-list $REVISIONS --left-right --cherry-pick | \
804                                 sed -n "s/^>//p" > "$DOTEST"/not-cherry-picks
805                         # Now all commits and note which ones are missing in
806                         # not-cherry-picks and hence being dropped
807                         git rev-list $REVISIONS |
808                         while read rev
809                         do
810                                 if test -f "$REWRITTEN"/$rev -a "$(sane_grep "$rev" "$DOTEST"/not-cherry-picks)" = ""
811                                 then
812                                         # Use -f2 because if rev-list is telling us this commit is
813                                         # not worthwhile, we don't want to track its multiple heads,
814                                         # just the history of its first-parent for others that will
815                                         # be rebasing on top of it
816                                         git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$DROPPED"/$rev
817                                         short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
818                                         sane_grep -v "^[a-z][a-z]* $short" <"$TODO" > "${TODO}2" ; mv "${TODO}2" "$TODO"
819                                         rm "$REWRITTEN"/$rev
820                                 fi
821                         done
822                 fi
824                 test -s "$TODO" || echo noop >> "$TODO"
825                 cat >> "$TODO" << EOF
827 # Rebase $SHORTREVISIONS onto $SHORTONTO
829 # Commands:
830 #  p, pick = use commit
831 #  r, reword = use commit, but edit the commit message
832 #  e, edit = use commit, but stop for amending
833 #  s, squash = use commit, but meld into previous commit
834 #  f, fixup = like "squash", but discard this commit's log message
836 # If you remove a line here THAT COMMIT WILL BE LOST.
837 # However, if you remove everything, the rebase will be aborted.
839 EOF
841                 has_action "$TODO" ||
842                         die_abort "Nothing to do"
844                 cp "$TODO" "$TODO".backup
845                 git_editor "$TODO" ||
846                         die "Could not execute editor"
848                 has_action "$TODO" ||
849                         die_abort "Nothing to do"
851                 test -d "$REWRITTEN" || skip_unnecessary_picks
853                 git update-ref ORIG_HEAD $HEAD
854                 output git checkout $ONTO && do_rest
855                 ;;
856         esac
857         shift
858 done